VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CheckBancari"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
Private Const L_CONTO As Integer = 12
Private Const L_ABI As Integer = 5
Private Const L_CAB As Integer = 5
Private mAbi As String
Private mCab As String
Private mContoCorrente As String
Private mCin As String
Private mIBAN As String
Private mBBAN As String
Private mCheckDigitIBAN As String
Private mPaese As String
Private mDivisore As Integer

Private Sub Class_Initialize()
    mContoCorrente = ""
    mCin = ""
    mIBAN = ""
    mBBAN = ""
    mCheckDigitIBAN = ""
    mPaese = "IT"
    mDivisore = 97
End Sub

Public Property Let Abi(ByVal vData As String)
    mAbi = vData
End Property

Public Property Get Abi() As String
    Abi = mAbi
End Property

Public Property Let Cab(ByVal vData As String)
    mCab = vData
End Property

Public Property Get Cab() As String
    Cab = mCab
End Property

Public Property Let ContoCorrente(ByVal vData As String)
    mContoCorrente = vData
End Property

Public Property Get ContoCorrente() As String
    ContoCorrente = mContoCorrente
End Property

Public Property Let Cin(ByVal vData As String)
    mCin = vData
End Property

Public Property Get Cin() As String
    Cin = mCin
End Property

Public Property Let IBAN(ByVal vData As String)
    mIBAN = vData
End Property

Public Property Get IBAN() As String
    IBAN = mIBAN
End Property

Public Property Let BBAN(ByVal vData As String)
    mBBAN = vData
End Property

Public Property Get BBAN() As String
    BBAN = mBBAN
End Property

Public Property Let CheckDigitIBAN(ByVal vData As String)
    mCheckDigitIBAN = vData
End Property

Public Property Get CheckDigitIBAN() As String
    CheckDigitIBAN = mCheckDigitIBAN
End Property

Public Property Let Paese(ByVal vData As String)
    mPaese = vData
End Property

Public Property Get Paese() As String
    Paese = mPaese
End Property

Public Property Let Divisore(ByVal vData As Integer)
    mDivisore = vData
End Property

Public Property Get Divisore() As Integer
    Divisore = mDivisore
End Property
Private Function NormalizzaDati(ByVal Codice As String, ByVal lunghezza As Integer) As String
    Codice = Right(String(lunghezza, "0") & Trim(Codice), lunghezza)
    NormalizzaDati = Codice
End Function

Public Function NormalizzaContoCorrente(ByVal pContoCorrente As String) As String
    pContoCorrente = Replace(pContoCorrente, " ", "", 1, , vbTextCompare)
    NormalizzaContoCorrente = NormalizzaDati(pContoCorrente, L_CONTO)
End Function

Public Function VerificaCin(ByVal cinCode As String) As Boolean
    VerificaCin = (cinCode = CalcolaCin)
End Function

Public Function CalcolaCin() As String
    Const Numeri As String = "0123456789"
    Const Lettere As String = "ABCDEFGHIJKLMNOPQRSTUVWXYZ-. "
    Const Divisore As Integer = 26
    Dim listaPari() As Variant
    Dim ListaDispari() As Variant
    Dim Codice As String, s As String
    Dim Somma As Integer
    Dim k As Integer, i As Integer
    listaPari = Array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28)
    ListaDispari = Array(1, 0, 5, 7, 9, 13, 15, 17, 19, 21, 2, 4, 18, 20, 11, 3, 6, 8, 12, 14, 16, 10, 22, 25, 24, 23, 27, 28, 26)
    mAbi = NormalizzaDati(mAbi, L_ABI)
    mCab = NormalizzaDati(mCab, L_CAB)
    ContoCorrente = NormalizzaContoCorrente(ContoCorrente)
    Codice = UCase(Abi + Cab + ContoCorrente)
    Somma = 0
    For k = 1 To (L_CONTO + L_ABI + L_CAB)
        s = Mid(Codice, k, 1)
        i = InStr(1, Numeri, s, vbTextCompare)
        If i = 0 Then
            i = InStr(1, Lettere, s, vbTextCompare)
        End If
        If i = 0 Then Exit Function
        i = i - 1
        If (k Mod 2) = 1 Then
            Somma = Somma + CInt(ListaDispari(i))
        Else
            Somma = Somma + CInt(listaPari(i))
        End If
    Next
    CalcolaCin = Mid(Lettere, Somma Mod Divisore + 1, 1)
End Function

Public Function CheckIBAN(Optional ByVal pIBAN As String = "") As Boolean
    Dim Codice As String
    Dim s As String
    Dim resto As Integer
    If Not (pIBAN = "") Then
        Codice = pIBAN
    Else
        s = ""
        Codice = ""
        If BBAN <> "" Then
            Codice = BBAN
        End If
        If s = "" And Cin <> "" And Abi <> "" And Cab <> "" And ContoCorrente <> "" Then
            s = CalcolaCin
            Codice = s + NormalizzaDati(mAbi, L_ABI) + NormalizzaDati(mCab, L_CAB) + NormalizzaContoCorrente(mContoCorrente)
        End If
        If Codice = "" Then
            CheckIBAN = False
            Exit Function
        End If
    End If
    Codice = NormalizzaIBAN(Codice)
    If Not CheckLength(Codice) Then
        CheckIBAN = False
        Exit Function
    End If
    Codice = Mid(Codice, 5) & Right(Codice, 4)
    Dim r() As String
    r = DivisioneIntera(AlfaToNumber(Codice), CStr(Divisore))
    resto = CInt(r(1))
    CheckIBAN = (resto = 1)
End Function

Public Function CalcolaBBAN() As String
    Dim Codice As String
    Dim s As String
    If Not (mIBAN = "") Then
        Codice = mIBAN
    Else
        s = mCin
        If s = "" Then
            s = CalcolaCin
        End If
        Codice = s + NormalizzaDati(mAbi, L_ABI) + NormalizzaDati(mCab, L_CAB) + NormalizzaContoCorrente(mContoCorrente)
    End If
    CalcolaBBAN = Codice
End Function

Public Function CalcolaCheckIBAN(ByVal pPaese As String, ByVal pBBAN As String) As String
    CalcolaCheckIBAN = Mid(CalcolaIBAN(pPaese, pBBAN), 3, 2)
End Function

Public Function CalcolaIBAN(Optional ByVal pPaese As String = "", Optional ByVal pBBAN As String = "") As String
    Dim Codice As String, NumCode As String
    Dim r() As String
    If pPaese = "" Then pPaese = mPaese
    Codice = pBBAN
    If Codice = "" Then Codice = mBBAN
    If Codice = "" Then Codice = CalcolaBBAN
    pBBAN = NormalizzaIBAN(Codice)
    Codice = pPaese + "00" + pBBAN
    Codice = Mid(Codice, 5) + Left(Codice, 4)
    NumCode = AlfaToNumber(Codice)
    r = Funzioni.DivisioneIntera(NumCode, CStr(Divisore))
    Dim resto As Integer
    resto = CInt(r(1))
    resto = (Divisore + 1) - resto
    CalcolaIBAN = pPaese + Format(resto, "00") + pBBAN
End Function

Public Function NormalizzaIBAN(ByVal pCodice As String) As String
    Const alfanum As String = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"
    Dim k As Integer, j As Integer
    Dim Codice As String, s As String
    Codice = ""
    pCodice = UCase(pCodice)
    For k = 1 To Len(pCodice)
        s = Mid(pCodice, k, 1)
        j = InStr(1, alfanum, s, vbTextCompare)
        If j <> 0 Then Codice = Codice & s
    Next
    NormalizzaIBAN = Codice
End Function

Private Function CheckLength(ByVal pCodice As String) As Boolean
    CheckLength = True
End Function

Private Function AlfaToNumber(ByVal pCodice As String) As String
    Const alfachars As String = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
    Dim s As String, Codice As String
    Dim k As Integer, i As Integer
    Codice = ""
    For k = 1 To Len(pCodice)
        s = Mid(pCodice, k, 1)
        i = InStr(1, alfachars, s, vbTextCompare)
        If i <> 0 Then
            Codice = Codice & CStr(i + 9)
        Else
            Codice = Codice & s
        End If
    Next
    AlfaToNumber = Codice
End Function





