Attribute VB_Name = "Module1"
Public Abi As String
Public Cab As String
Public ContoCorrente As String
Public Cin As String
Public Const L_CONTO As Integer = 12
Public Const L_ABI As Integer = 5
Public Const L_CAB As Integer = 5
Public IBAN As String
Public BBAN As String
Public CheckDigitIBAN
Public Paese As String
Public Divisore As Integer


Private Function NormalizzaDati(ByVal codice As String, ByVal lunghezza As Integer) As String
    NormalizzaDati = Right(String(lunghezza, "0") + Trim(codice), lunghezza)
End Function

Public Function NormalizzaContoCorrente(ByVal contoCorrenteValue As String) As String
    contoCorrenteValue = Trim(contoCorrenteValue)
    Dim codice As String
    Dim s As String
    s = ""
    For k = 1 To Len(contoCorrenteValue)
        s = Mid(contoCorrenteValue, k, 1)
        If s <> " " Then codice = codice & s
    Next
    ContoCorrente = NormalizzaDati(codice, L_CONTO)
    NormalizzaContoCorrente = ContoCorrente
End Function

Public Function VerificaCin(ByVal cinCode As String) As Boolean
    VerificaCin = (cinCode = CalcolaCin)
End Function

Public Function CalcolaCin() As String
    Const Numeri As String = "0123456789"
    Const Lettere As String = "ABCDEFGHIJKLMNOPQRSTUVWXYZ-. "
    Const Divisore As Integer = 26
    Dim listaPari() As Integer
    listaPari = Array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28)
    Dim listaDispari() As Integer
    listaDispari = Array(1, 0, 5, 7, 9, 13, 15, 17, 19, 21, 2, 4, 18, 20, 11, 3, 6, 8, 12, 14, 16, 10, 22, 25, 24, 23, 27, 28, 26)
    Abi = NormalizzaDati(Abi, L_ABI)
    Cab = NormalizzaDati(Cab, L_CAB)
    NormalizzaContoCorrente (ContoCorrente)
    Dim codice As String
    codice = Abi + Cab + ContoCorrente
    Dim somma As Integer
    somma = 0
    ' Dim c As Char() = codice.ToUpper.ToCharArray
    Dim k As Integer
    Dim s As String
    Dim i As Integer
    For k = 1 To L_CONTO + L_ABI + L_CAB
        s = Mid(ContoCorrente, k, 1)
        i = InStr(1, Numeri, s, vbTextCompare)
        If i = 0 Then i = InStr(1, Lettere, s, vbTextCompare)
        i = i - 1
        If i = 0 Then
            CalcolaCin = vbCrLf
            Exit Function
        End If
        If (k Mod 2) = 1 Then
            somma = somma + listaDispari(i)
        Else
            somma = somma + listaPari(i)
        End If
    Next
    Cin = Mid(Lettere, somma Mod Divisore + 1, 1)
    CalcolaCin = Cin
End Function


Public Function CheckIBAN(Optional ByVal pIBAN As String = "") As Boolean
    Dim codice As String
    Dim b As Boolean
    If pIBAN = "" Then
        If Not (IBAN = "") Then
            pIBAN = IBAN
        Else
            codice = Cin
            If Not (codice = "") Then
                b = VerificaCin(codice)
                If Not b Then
                    CheckIBAN = False
                    Exit Function
                End If
            Else
                codice = CalcolaCin
                Cin = codice
            End If
            pIBAN = s + NormalizzaDati(mAbi, L_ABI) + NormalizzaDati(mCab, L_CAB) + NormalizzaContoCorrente(mContoCorrente)
        End If
    Else
        pIBAN = IBAN
    End If
    pIBAN = NormalizzaIBAN(pIBAN)
    codice = Mid(pIBAN, 5) + Left(pIBAN, 4)
    Dim r() As String
    r = DivisioneIntera(AlfaToNumber(codice), CStr(Divisore))
    Dim resto As Integer
    resto = CInt(r(1))
    CheckIBAN = (resto = 1)
End Function

Public Function CalcolaBBAN(Optional ByVal pIBAN As String = "") As String
    Dim codice As String
    Dim s As String
    If pIBAN = "" Then pIBAN = IBAN
    If Not (pIBAN = "") Then
        codice = pIBAN
    Else
        s = Cin
        If s = "" Then
            s = CalcolaCin
        End If
        codice = s + NormalizzaDati(mAbi, L_ABI) + NormalizzaDati(mCab, L_CAB) + NormalizzaContoCorrente(mContoCorrente)
    End If
    CalcolaBBAN = codice
End Function

Public Function CalcolaIBAN(Optional pBBAN As String) As String
    Dim codice As String
    If pBBAN = "" Then pBBAN = IBAN
    If Not (pBBAN = "") Then
        codice = pBBAN
    Else
        codice = CalcolaBBAN
    End If

    Return CalcolaIBAN(mPaese, codice)
End Function

Public Function CalcolaCheckIBAN(ByVal pPaese As String, ByVal pBBAN As String) As String
    Return CalcolaIBAN(pPaese, pBBAN).Substring(2, 2)
End Function

Public Function CalcolaIBAN(ByVal pPaese As String, ByVal pBBAN As String) As String
    pBBAN = NormalizzaIBAN(pBBAN)
    Dim codice As String = pPaese + "00" + pBBAN
    codice = codice.Substring(4) + codice.Substring(0, 4)
    Dim numcode As String = AlfaToNumber(codice)
    Dim r As String() = Funzioni.DivisioneIntera(numcode, Divisore.ToString)
    Dim resto As Integer = Integer.Parse(r(1))
    resto = (Divisore + 1) - resto
    Return pPaese + resto.ToString("00") + pBBAN
End Function

Public Function NormalizzaIBAN(ByVal pCodice As String) As String
    Const alfanum As String = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"
    Dim sb As StringBuilder = New StringBuilder
    For Each c As Char In pCodice
        If Not (alfanum.IndexOf(c) = -1) Then
            sb.Append (c)
        End If
    Next
    Return sb.ToString
End Function

Private Function CheckLength(ByVal pCodice As String) As Boolean
    Return True
End Function

Private Function AlfaToNumber(ByVal pCodice As String) As String
    Const alfachars As String = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
    Dim sb As StringBuilder = New StringBuilder
    For Each c As Char In pCodice
        Dim k As Integer = alfachars.IndexOf(c)
        If Not (k = -1) Then
            sb.Append (k + 10)
        Else
            sb.Append (c)
        End If
    Next
    Return sb.ToString
End Function
